
package br.com.topologica;

import br.com.topologica.view.MainContainerView;
import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

/**
 * The main class of the application.
 */
public class VideoMonMobile extends SingleFrameApplication {

    /**
     * At startup create and show the main frame of the application.
     */
    @Override
    protected void startup() {
        MainContainerView mainContainerView = new MainContainerView(this);
        show(mainContainerView);
        mainContainerView.showOpenFileconfiguration();
        //mainContainerView.loadXmlConfiguration(null);
    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     */
    @Override
    protected void configureWindow(java.awt.Window root) {
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of DesktopApplication1
     */
    public static VideoMonMobile getApplication() {
        return Application.getInstance(VideoMonMobile.class);
    }

    /**
     * Main method launching the application.
     */
    public static void main(String[] args) {
       

            launch(VideoMonMobile.class, args);
      
    }
}
