/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.topologica.task;



import br.com.topologica.VideoMonMobile;
import br.com.topologica.parse.GpsParse;
import br.com.topologica.view.MainContainerView;
import br.com.topologica.vo.Connection;
import br.com.topologica.vo.GPSPoint;
import br.com.topologica.vo.Vehicle;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.geom.Point2D;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.jdesktop.application.Application;
import org.jdesktop.application.Task;
import org.jdic.web.BrMap;
import org.jdic.web.BrMapBalloonSprite;

/**
 *
 * @author 
 */
public class VehicleTask extends Task{

    private boolean cancel;
    private BrMap brMap;
    private Vehicle vehicle;

    private static double DESLOCAMENTO_TESTE =-0.3;
    private  static double DESLOCAMENTO_LONG =-0.3;

    
    public Vehicle getVehicle() {
        return vehicle;
    }

    public void setVehicle(Vehicle vehicle) {
        this.vehicle = vehicle;
    }

    public BrMap getBrmap() {
        return brMap;
    }

    public void setBrmap(BrMap brmap) {
        this.brMap = brmap;
    }

    public VehicleTask(Application app) {
        super(app, "LoadImageTask"); // init title/description/messages
      MainContainerView mainView = (MainContainerView)((VideoMonMobile)app).getMainView();
      brMap = mainView.getMapPanel1().getBrMap1();
    }


    @Override
    protected  Object doInBackground() throws Exception {

        double centerLat = 0, centerLng = 0;
        boolean hasMore = true;
       
        GpsParse gpsParse = new GpsParse();
         //URL u = new URL("http://vpn.lab.unb.br:2947/w");
        Connection connectionGps = this.vehicle.getGps().getConnection();
        String urlVehicle = "http://"+connectionGps.getHost()+ ":" + connectionGps.getPort()+"/"+connectionGps.getParameters().getTipo();
        URL u = new URL(urlVehicle);
         
         
         
         DESLOCAMENTO_LONG += (Math.random() -0.5) * 1;
         DESLOCAMENTO_TESTE += (Math.random() -0.5) * 1;
         double desvioLatitude = DESLOCAMENTO_TESTE;
         double desvioLongitude = DESLOCAMENTO_LONG;
         System.out.println("DESLOCAMENTO_TESTE:"+DESLOCAMENTO_LONG);
          GPSPoint track = new GPSPoint();
          GPSPoint track2 = new GPSPoint();
          BufferedReader br = new BufferedReader(new InputStreamReader(u.openStream()));
        while (!cancel) {
            try {
               desvioLatitude+= (Math.random() -0.5) * 0.2;
               desvioLongitude+= (Math.random() -0.5) * 0.1;
                
                //System.out.println("firstreadLine :"+br.readLine());

                String dadoGPS = br.readLine();
                System.out.println("dadoGPS1 :"+dadoGPS);

//                 br.readLine();
//
//                 dadoGPS = br.readLine();
//                System.out.println("dadoGPS2 :"+dadoGPS);
                
                if (dadoGPS.charAt(5) == 'O') {
                    System.out.println(dadoGPS);
                    gpsParse.executeParse(dadoGPS,vehicle);;
                    double latitude = gpsParse.getLatitude();
                    double longitude = gpsParse.getLongitude();

                             
                             
                                double distancia = BrMap.getDistance(latitude, longitude, centerLat, centerLng);
                            
                                track.setVehicle(vehicle);

                                vehicle.setLatitude(latitude+desvioLatitude);
                                vehicle.setLongitude(longitude+desvioLongitude);
                                track.GPSPoint(latitude+desvioLatitude, longitude+desvioLongitude);
                                track.add(brMap);
                                brMap.repaint();
                                System.out.println("sizes:"+brMap.getSprites().size());

                              
//                                System.out.println("centerLatdistancia:"+centerLat);
//                                System.out.println("distancia:"+distancia);

                
                            
                    centerLat = latitude;
                    centerLng = longitude;
//                    System.out.println(vehicle.getId()+" : latitude:" + latitude);
//                    System.out.println("longitude:"+longitude);
                    
                }
                
                 Thread.sleep(1000);
            } catch (Exception e) {
                e.printStackTrace();
            }
         
               
           
        }

        return null;
    }

   

    @Override
    protected void cancelled() {
        System.out.println("cancelado");
        cancel = true;
    }
}
